;;; Elipstag.lsp
;;;
;;; Boilerplate:
;;;
;;; This is a program to drag and draw an arrow point, one or 
;;; several lines and an ellipsoidal (false ellipse) balloon 
;;; and draw text inside of it.
;;;
;;; If you have crammed up drawings give it a try, once you get used 
;;; to it it'll become part of your daily work.
;;;
;;; If your machine is any slower than a i486-66 you may be disapointed
;;; with the speed at wich this program runs.
;;;
;;; This thing is mine but I will not be held responsible for it's 
;;; misbehavior if there is.
;;;
;;;
;;; Yvan Paquet  
;;; Tel: 514-641-2913
;;; Compuserve ID: 76460,774

;;; Error traps
(defun tagerror (msg)
 (if (member msg '("console break" "Function cancelled" "Cancel"))
  (princ "\n*User ")
  (princ (strcat "\nError: " msg))
  );if
 (grvecs ervlst)
 (setq drg T
       ervlst nil
  );setq
 (tagreset)
 (princ)
 );defun

(defun tagcfgerr (cfmsg)
 (if (member cfmsg '("console break" "Function cancelled" "Cancel"))
  (princ "\n*User ")
  (princ (strcat "\nError: " cfmsg))
  );if
 (setq *error* acaderr)
 (princ)
 );defun

;;; Reset function
(defun tagreset ()
 (setvar "osmode" osm)
 (setvar "orthomode" ort)
 (setvar "snapmode" sna)
 (setvar "blipmode" blip)
 (setvar "cmdecho" eco)
 (setvar "clayer" cla)
 (setq *error* acaderr)
 );defun


;;; Main function
(defun elipstag (/ Tkwd osm sna asz dtex dscal balstr bx hrl vrl apnt apntx 
                   apnty dzro id pxpt pxptx pxpty pxptz tcenpt lcenpt bxl bxr 
                   p1 p2 p3 p4 tangr tangl tang bangr bangl bang angp1 angp2 
                   angp3 angp4 lang rang lncr sncr lrad srad p11 p12 p13 p14 
                   p15 p16 p17 p21 p22 p23 p24 p25 p31 p32 p33 p34 p35 p36 
                   p37 p41 p42 p43 p44 p45 pcut vlst ervlst drg 1stpk txtht 
                   acaderr blip pa pb eco ort ptmp defstr pcut fuz apnt1 
                   apnt2 cla fla lanam xth lacfg lacol wstr col#)
 (setq fuz (* 0.01 (getvar "dimscale"))
       cla (getvar "clayer")
       fla (cdr (assoc 70 (tblsearch "layer" "DE$C")))
       lanam (cdr (assoc 2 (tblsearch "layer" "DE$C")))
       osm (getvar "osmode")
       ort (getvar "orthomode")
       sna (getvar "snapmode")
       blip (getvar "blipmode")
       eco (getvar "cmdecho")
       asz (getvar "dimasz")
       dtex (getvar "dimtxt")
       dcsal (getvar "dimscale")
       txtht (getvar "textsize")
       shift (getvar "users2")
       wstr (getvar "users5")
       lacfg ""
       acaderr *error*
       *error* tagerror
       Tkwd T
  );setq
 (setvar "osmode" 0)
 (setvar "orthomode" 0)
 (setvar "snapmode" 0)
 (setvar "blipmode" 0)
 (setvar "cmdecho" 0)
 (if (/= (getvar "cmdnames") "")(progn (princ "\nElipstag not available transparently")
                                       (princ)(tagreset)(setq Tkwd nil)(princ))
  );if
 (while (wcmatch wstr "* *")
         (setq lacfg (strcat lacfg (substr wstr 1 1))
               wstr (substr wstr 2)
               lacol (strcase wstr)
          );setq
         (if (wcmatch lacfg "* ")
              (setq lacfg (substr lacfg 1 (1- (strlen lacfg))))
          );if
  );while
 (cond
  ((= lacol "RED")
    (setq col# 1)
   );cond1
  ((= lacol "YELLOW")
    (setq col# 2)
   );cond1
  ((= lacol "GREEN")
    (setq col# 3)
   );cond1
  ((= lacol "CYAN")
    (setq col# 4)
   );cond1
  ((= lacol "BLUE")
    (setq col# 5)
   );cond1
  ((= lacol "MAGENTA")
    (setq col# 6)
   );cond1
  ((= lacol "WHITE")
    (setq col# 7)
   );cond1
  );cond
 (cond
  ((not lanam)
    (command "layer" "m" "DE$C" "c" "blue" "" "")
   );cond1
  ((> (strlen lacfg) 0)
    (command "layer" "m" lacfg "c" lacol "" "")
   );cond1
  ((and lanam
        (/= fla 64)
    );and
    (command "layer" "t" "DE$C" "on" "DE$C" "u" "DE$C" "s" "DE$C" "")
   );cond2
  ((and lanam
        (= fla 64)
    );and
    (command "layer" "on" "DE$C" "u" "DE$C" "s" "DE$C" "")
   );cond3
  );cond ovrall
 (while Tkwd
 (while (or (not balstr)(= (strlen balstr) 0))
  (setq defstr (getvar "users1")
        promp (strcat "\nEnter text <" defstr ">: ")
   );setq
  (setq balstr (getstring T promp))
  (if (and (= (strlen balstr) 0)(/= (strlen defstr) 0))(setq balstr defstr))
  (if (= (strlen balstr) 0)
       (princ "\nNo null string. Ctrl+C to quit or")
       (setvar "users1" balstr)
   );if
  (if (or (= shift "All")(= shift "Typed"))
       (progn
        (setq balstr (strcase balstr))
        (setvar "users1" balstr)
        );progn
   );if
  );while
  (if (or (= (ascii balstr) 32)(= (ascii balstr) 46))
       (setq hrl (/ txtht 2)
             vrl (/ txtht 2)
        );setq
       (setq bx (textbox (list (cons 1 balstr)))
             hrl (/ (caadr bx) 2)
             vrl (/ (cadadr bx) 2)
        );setq
   );if
 (while (not apnt)
  (graphscr)
  (setq apnt (getpoint "\nEnter arrow point: "))
  (if (not apnt)(princ "\nNo null pick. Ctrl+C to quit or")
      (setq 1stpk T)
   );if
  );while
 (setq apntx (car apnt)
       apnty (cadr apnt)
  );setq
 (prompt "\nPick next Point or Enter to place Text: ")
 (princ)
 (while apnt
   (setq dzro (grread T 5 1)
         id (car dzro)
    );setq
  (if (or (= id 5)
          (= id 3)
       );or
  (setq pxpt (cadr dzro)
        pxptx (caadr dzro)
        pxpty (cadadr dzro)
        pxptz (car (cddadr dzro))
   );setq
   );if
  (cond
   ((or (equal dzro (list 6 0))(equal dzro (list 2 13)))
      (grvecs ervlst)
      (setq drg T
            ervlst nil
       );setq
      (entmake (list ntypa
                     lanam
                     (cons 62 col#)
                     (cons 10 lcenpt)
                     (cons 40 (distance lcenpt p1))
                     (cons 50 angp1)
                     (cons 51 angp2)
                     xth
                );list
       );entmake
      (entmake (list ntypa
                     lanam
                     (cons 62 col#)
                     (cons 10 bxl)
                     (cons 40 (distance bxl p2))
                     (cons 50 angp2)
                     (cons 51 angp3)
                     xth
                );list
       );entmake
      (entmake (list ntypa
                     lanam
                     (cons 62 col#)
                     (cons 10 tcenpt)
                     (cons 40 (distance tcenpt p3))
                     (cons 50 angp3)
                     (cons 51 angp4)
                     xth
                );list
       );entmake
      (entmake (list ntypa
                     lanam
                     (cons 62 col#)
                     (cons 10 bxr)
                     (cons 40 (distance bxr p4))
                     (cons 50 angp4)
                     (cons 51 angp1)
                     xth
                );list
       );entmake
      (entmake (list ntypt
                     lanam
                     (cons 62 col#)
                     (list 10 0.0 0.0 0.0)
                     (cons 40 txtht)
                     (cons 1 balstr)
                     (cons 7 (getvar "textstyle"))
                     (cons 72 4)
                     (append (list 11) pxpt)
                     xth
                );list
       );entmake
      (if 1stpk
       (entmake (list (cons 0 "SOLID")
                      lanam
                      (cons 62 col#)
                      (cons 10 apnt)
                      (cons 11 apnt1)
                      (cons 12 apnt2)
                      (cons 13 apnt2)
                      xth
                 );list
        );entmake
       );if
      (entmake (list (cons 0 "LINE")
                     lanam
                     (cons 62 col#)
                     (cons 10 apnt)
                     (cons 11 pcut)
                     xth
                );list
       );entmake
      (tagreset)
      (setq apnt nil
            Tkwd nil)
      (princ)
    );cond 6 0
   ((and (= id 5)(not (equal pxpt ptmp 0.05)))
     (setq ptmp pxpt
           tcenpt (list pxptx (+ pxpty (* hrl 4)) pxptz)
           lcenpt (list pxptx (- pxpty (* hrl 4)) pxptz)
           bxl (list (- pxptx hrl) pxpty pxptz)
           bxr (list (+ pxptx hrl) pxpty pxptz)
           p1 (polar bxr (angle lcenpt bxr)(* vrl 1.75))
           p2 (polar bxl (angle lcenpt bxl)(* vrl 1.75))
           p3 (polar bxl (angle tcenpt bxl)(* vrl 1.75))
           p4 (polar bxr (angle tcenpt bxr)(* vrl 1.75))
           angp1 (angle lcenpt bxr)
           angp2 (angle lcenpt bxl)
           angp3 (angle tcenpt bxl)
           angp4 (angle tcenpt bxr)
           ntypa (cons 0 "ARC")
           ntypt (cons 0 "TEXT")
           lanam (cons 8 "DE$C")
           xth (list 210 0.0 0.0 1.0)
           tangr (angle tcenpt bxr)
           tangl (angle tcenpt bxl)
           tang (- tangr tangl)
           bangr (angle lcenpt bxr)
           bangl (angle lcenpt bxl)
           bang (- bangl bangr)
           angp1 (angle bxr p1)
           angp2 (angle bxl p2)
           angp3 (angle bxl p3)
           angp4 (angle bxr p4)
           lang (- angp3 angp2)
           rang (+ (- (* pi 2) angp4)(angle bxr p1))
           lncr (/ bang 8)
           sncr (/ lang 6)
           lrad (distance lcenpt p1)
           srad (distance bxr p1)
           p11 (polar lcenpt (+ (angle lcenpt p1) lncr)(distance lcenpt p1))
           p12 (polar lcenpt (+ (angle lcenpt p11) lncr)(distance lcenpt p1))
           p13 (polar lcenpt (+ (angle lcenpt p12) lncr)(distance lcenpt p1))
           p14 (polar lcenpt (+ (angle lcenpt p13) lncr)(distance lcenpt p1))
           p15 (polar lcenpt (+ (angle lcenpt p14) lncr)(distance lcenpt p1))
           p16 (polar lcenpt (+ (angle lcenpt p15) lncr)(distance lcenpt p1))
           p17 (polar lcenpt (+ (angle lcenpt p16) lncr)(distance lcenpt p1))
           p21 (polar bxl (+ (angle bxl p2) sncr)(distance bxl p2))
           p22 (polar bxl (+ (angle bxl p21) sncr)(distance bxl p2))
           p23 (polar bxl (+ (angle bxl p22) sncr)(distance bxl p2))
           p24 (polar bxl (+ (angle bxl p23) sncr)(distance bxl p2))
           p25 (polar bxl (+ (angle bxl p24) sncr)(distance bxl p2))
           p31 (polar tcenpt (+ (angle tcenpt p3) lncr)(distance tcenpt p3))
           p32 (polar tcenpt (+ (angle tcenpt p31) lncr)(distance tcenpt p3))
           p33 (polar tcenpt (+ (angle tcenpt p32) lncr)(distance tcenpt p3))
           p34 (polar tcenpt (+ (angle tcenpt p33) lncr)(distance tcenpt p3))
           p35 (polar tcenpt (+ (angle tcenpt p34) lncr)(distance tcenpt p3))
           p36 (polar tcenpt (+ (angle tcenpt p35) lncr)(distance tcenpt p3))
           p37 (polar tcenpt (+ (angle tcenpt p36) lncr)(distance tcenpt p3))
           p41 (polar bxr (+ (angle bxr p4) sncr)(distance bxr p4))
           p42 (polar bxr (+ (angle bxr p41) sncr)(distance bxr p4))
           p43 (polar bxr 0.0 (distance bxr p4))
           p44 (polar bxr sncr (distance bxr p4))
           p45 (polar bxr (+ (angle bxr p44) sncr)(distance bxr p4))
      );setq
     (cond
          ((and (<= pxpty apnty)(> (angle lcenpt apnt) angp1)
                (< (angle lcenpt apnt) angp2))
           (setq pcut (polar lcenpt (angle lcenpt apnt) lrad)))
          ((and (> (angle bxl apnt) angp2)(< (angle bxl apnt) angp3))
           (setq pcut (polar bxl (angle bxl apnt) srad)))
          ((and (>= pxpty apnty)(> (angle tcenpt apnt) angp3)
                (< (angle tcenpt apnt) angp4))
           (setq pcut (polar tcenpt (angle tcenpt apnt) lrad)))
          ((or (> (angle bxr apnt) angp4)(< (angle bxr apnt) angp1))
           (setq pcut (polar bxr (angle bxr apnt) srad)))
      );cond
     (if (and pcut apnt)
      (setq
           apnt1 (polar apnt (- (angle apnt pcut) 0.165) txtht)
           apnt2 (polar apnt (+ (angle apnt pcut) 0.165) txtht)
       );setq
      );if
     (if 1stpk
      (setq
            vlst (list 256 p1 p11 p11 p12 p12 p13 p13 p14 p14 p15 p15 p16 p16 
                           p17 p17 p2 p2 p21 p21 p22 p22 p23 p23 p24 p24 p25 
                           p25 p3 p3 p31 p31 p32 p32 p33 p33 p34 p34 p35 p35 
                           p36 p36 p37 p37 p4 p4 p41 p41 p42 p42 p43 p43 p44 
                           p44 p45 p45 p1 apnt pcut apnt 
                           apnt1 apnt1 apnt2 apnt2 apnt)
       );setq
      (setq
            vlst (list 256 p1 p11 p11 p12 p12 p13 p13 p14 p14 p15 p15 p16 p16 
                           p17 p17 p2 p2 p21 p21 p22 p22 p23 p23 p24 p24 p25 
                           p25 p3 p3 p31 p31 p32 p32 p33 p33 p34 p34 p35 p35 
                           p36 p36 p37 p37 p4 p4 p41 p41 p42 p42 p43 p43 p44 
                           p44 p45 p45 p1 apnt pcut)
       );setq
       );if
    (if (not (equal vlst ervlst fuz))
         (progn
          (grvecs ervlst)
          (setq drg T
                ervlst nil
           );setq
          );progn
     );if
    (if (and vlst drg)
         (progn
          (grvecs vlst)
          (setq drg nil
                ervlst vlst
                vlst nil
           );setq
          );progn
     );if
    );cond id5
   ((= id 3)
      (grvecs ervlst)
      (setq drg T
            ervlst nil
       );setq
      (if 1stpk
       (entmake (list (cons 0 "SOLID")
                      lanam
                      (cons 62 col#)
                      (cons 10 apnt)
                      (cons 11 apnt1)
                      (cons 12 apnt2)
                      (cons 13 apnt2)
                      xth
                 );list
        );entmake
       );if
       (entmake (list (cons 0 "LINE")
                      lanam
                      (cons 62 col#)
                      (cons 10 apnt)
                      (cons 11 pcut)
                      xth
                 );list
        );entmake
      (setq apnt pcut
            1stpk nil
            ptmp nil
       );setq
    );cond id3
   );cond overall
  );while apnt
 );while tkwd
 (princ)
 );defun


(defun tagcfg ( / caps lastr lacfg colstr lacol wstr)
 (setq acaderr *error*
       *error* tagcfgerr
       caps (getvar "users2")
  );setq
 (initget "All Typed Shifted")
 (cond
  ((= caps "All")
   (setq caps (getkword "\nUppercase text: Typed, Shifted, <All> ?: ")))
  ((= caps "Typed")
   (setq caps (getkword "\nUppercase text: All, Shifted, <Typed> ?: ")))  
  ((or (= caps "Shifted")(= caps ""))
   (setq caps (getkword "\nUppercase text: All, Typed, <Shifted> ?: ")))
  );cond
 (if caps (setvar "users2" caps))
 (setq lacfg (cdr (assoc 2 (tblsearch "layer" "DE$C")))
       lacol (cdr (assoc 62 (tblsearch "layer" "DE$C")))
       wstr (getvar "users5")
  );setq
 (if (and (not lacfg)(= (strlen wstr) 0))(setq lacfg "DE$C"))
 (if (and (not lacol)(= (strlen wstr) 0))(setq lacol "BLUE"))
 (if (> (strlen wstr) 0)
  (progn
   (setq lacfg "")
   (while (wcmatch wstr "* *")
           (setq lacfg (strcat lacfg (substr wstr 1 1))
                 wstr (substr wstr 2)
                 lacol wstr
            );setq
           (if (wcmatch lacfg "* ")
                (setq lacfg (substr lacfg 1 (1- (strlen lacfg))))
            );if
    );while
   );progn
  );if
 (while (numberp lacol)
  (cond
   ((= lacol 1)
     (setq lacol "RED")
    );cond1
   ((= lacol 2)
     (setq lacol "YELLOW")
    );cond1
   ((= lacol 3)
     (setq lacol "GREEN")
    );cond1
   ((= lacol 4)
     (setq lacol "CYAN")
    );cond1
   ((= lacol 5)
     (setq lacol "BLUE")
    );cond1
   ((= lacol 6)
     (setq lacol "MAGENTA")
    );cond1
   ((= lacol 7)
     (setq lacol "WHITE")
    );cond1
   );cond ovral
  );while
 (setq promp (strcat "\nEnter Layer name for DESCription text <" lacfg ">:")
       lastr (getstring promp))
 (if (> (strlen lastr) 0) (setq lacfg lastr))
 (initget "Red Yellow Green Cyan Blue Magenta White 1 2 3 4 5 6 7")
 (setq promp (strcat "\nEnter Color name for DESCription text <" lacol ">:")
       colstr (getkword promp))
 (if (or (not colstr) (> (strlen colstr) 0))(setq lacol colstr))
 (cond
  ((= lacol "1")
    (setq lacol "RED")
   );cond
  ((= lacol "2")
    (setq lacol "YELLOW")
   );cond
  ((= lacol "3")
    (setq lacol "GREEN")
   );cond
  ((= lacol "4")
    (setq lacol "CYAN")
   );cond
  ((or (= lacol "5")(not lacol))
    (setq lacol "BLUE")
   );cond
  ((= lacol "6")
    (setq lacol "MAGENTA")
   );cond
  ((= lacol "7")
    (setq lacol "WHITE")
   );cond
  );cond ovral
 (setvar "users5" (strcat lacfg " " lacol))
 (setq *error* acaderr)
 (princ)
 );defun


(defun C:tagcfg ()
(tagcfg))

(defun C:tag ()
(elipstag))

(princ "\n    ***   Elipstag Loaded   ***")
(princ "\n* Main: C:Tag ** Config: C:Tagcfg *")
(princ)

